var util = require('../../utils/util.js');
var api = require('../../config/api.js');
var app = getApp();
Page({
  data: {
    brandList: [],
    page: 1,
    size: 10,
    totalPages: 1
  },
  onLoad: function(options) {
    // 页面初始化 options为页面跳转所带来的参数
    this.getBrandList();
  },
  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh() {
    this.getBrandList();
    wx.hideNavigationBarLoading() //完成停止加载
    wx.stopPullDownRefresh() //停止下拉刷新
  },
  getBrandList: function() {
    wx.showLoading({
      title: '加载中...',
    });
    let that = this;
    util.request(api.BrandList, {
      page: that.data.page,
      size: that.data.size
    }).then(function(res) {
      if (res.errno === 0) {
        that.setData({
          brandList: that.data.brandList.concat(res.data.brandList),
          totalPages: res.data.totalPages
        });
      }
      that.configList(res.data.brandList)
      wx.hideLoading();
    });
  },
  configList(brandList) {
    for(let i=0; i<brandList.length; i++) {
      brandList[i].nodes = this.configNode(brandList[i].desc);
    }
    this.setData({
      brandList
    })
  },
  configNode(desc) {
    let _tempDesc = desc.split('|'),
      _tempNodes = [];
    for (let i = 0; i < _tempDesc.length; i++) {
      let _tempObj = {
        name: 'div',
        attrs: {
          class: 'div_class',
          style: 'color: #666666; font-size: 30rpx; margin-left:31rpx;'
        },
        children: [{
          type: 'text',
          text: ""
        }]
      };
      _tempObj.children[0].text = _tempDesc[i];
      _tempNodes.push(_tempObj);
    }
    return _tempNodes
  },
  onReachBottom() {
    if (this.data.totalPages > this.data.page) {
      this.setData({
        page: this.data.page + 1
      });
    } else {
      return false;
    }

    this.getBrandList();
  },
  onReady: function() {

  },
  onShow: function() {
    // 页面显示

  },
  onHide: function() {
    // 页面隐藏

  },
  onUnload: function() {
    // 页面关闭

  }
})