const util = require('../../utils/util.js');
const api = require('../../config/api.js');
const user = require('../../utils/user.js');

//获取应用实例
const app = getApp();

Page({
  data: {
    newGoods: [],
    hotGoods: [],
    topics: [],
    brands: [],
    groupons: [],
    floorGoods: [],
    banner: [],
    channel: [],
    coupon: [],
    ad: []
  },

  onShareAppMessage: function() {
    return {
      title: '戈友商城',
      desc: '戈友商城',
      path: '/pages/index2/index2'
    }
  },

  onPullDownRefresh() {
    this.getIndexData();
    wx.hideNavigationBarLoading() //完成停止加载
    wx.stopPullDownRefresh() //停止下拉刷新
  },

  getIndexData: function() {
    let that = this;
    util.request(api.IndexUrl).then(function(res) {
      if (res.errno === 0) {
        that.setData({
          newGoods: res.data.newGoodsList,//新品  
          hotGoods: res.data.hotGoodsList,//人气
          topics: res.data.topicList,
          brands: res.data.brandList,
          floorGoods: res.data.floorGoodsList,
          // banner: res.data.banner,   //轮播图
          groupons: res.data.grouponList,
          channel: res.data.channel,  //户外分类
          coupon: res.data.couponList
        });
        
        that.getAdBanner(res.data.banner)
      }
    });
  },
  
  getAdBanner(data) {
    let _ad = [],
    _banner = [];
    for (let i = 0; i < data.length; i++) {
      if (data[i].position === 2) {
        _ad.push(data[i]);
      } else {
        _banner.push(data[i])
      }
    }
    this.setData({
      banner: _banner,
      ad: _ad
    })
  },

  goActivity:function(e){
    var name=e.target.dataset.name,
      link = e.target.dataset.link;
    if (link.indexOf('pages')>-1){
      wx.navigateTo({
        url: link
      });
    } else {
      wx.navigateTo({
        url: `../activity/activity?name=${name}&link=${link}`
      });
    }
  },
  onLoad: function(options) {
    console.log("options",options);
    // 页面初始化 options为页面跳转所带来的参数
    if (options.scene) {
      //这个scene的值存在则证明首页的开启来源于朋友圈分享的图,同时可以通过获取到的goodId的值跳转导航到对应的详情页
      var scene = decodeURIComponent(options.scene);
      console.log("scene:" + scene);

      let info_arr = [];
      info_arr = scene.split(',');
      let _type = info_arr[0];
      let id = info_arr[1];

      if (_type == 'goods') {
        wx.navigateTo({
          url: '../goods/goods?id=' + id
        });
      } else if (_type == 'groupon') {
        wx.navigateTo({
          url: '../goods/goods?grouponId=' + id
        });
      } else {
        wx.navigateTo({
          url: '../index2/index2'
        });
      }
    }

    // 页面初始化 options为页面跳转所带来的参数
    if (options.grouponId) {
      //这个pageId的值存在则证明首页的开启来源于用户点击来首页,同时可以通过获取到的pageId的值跳转导航到对应的详情页
      wx.navigateTo({
        url: '../goods/goods?grouponId=' + options.grouponId
      });
    }

    // 页面初始化 options为页面跳转所带来的参数
    if (options.goodId) {
      //这个goodId的值存在则证明首页的开启来源于分享,同时可以通过获取到的goodId的值跳转导航到对应的详情页
      wx.navigateTo({
        url: '../goods/goods?id=' + options.goodId
      });
    }

    // 页面初始化 options为页面跳转所带来的参数
    if (options.orderId) {
      //这个orderId的值存在则证明首页的开启来源于订单模版通知,同时可以通过获取到的pageId的值跳转导航到对应的详情页
      wx.navigateTo({
        url: '../ucenter/orderDetail/orderDetail?id=' + options.orderId
      });
    }

    this.getIndexData();
  },
  onReady: function() {
    // 页面渲染完成
  },
  onShow: function() {
    // 页面显示
  },
  onHide: function() {
    // 页面隐藏
  },
  onUnload: function() {
    // 页面关闭
  },
  getCoupon(e) {
    if (!app.globalData.hasLogin) {
      wx.navigateTo({
        url: "/pages/auth/login/login"
      });
    }

    let couponId = e.currentTarget.dataset.id,
      index = e.currentTarget.dataset.index,
      that = this;
    util.request(api.CouponReceive, {
      couponId: couponId
    }, 'POST').then(res => {
      if (res.errno === 0) {
        wx.showToast({
          title: "领取成功"
        })
        let _coupon = that.data.coupon;
        _coupon.splice(index, 1);
        that.setData({
          coupon: _coupon
        })
      }
      else{
        util.showErrorToast(res.errmsg);
      }
    })
  },

  openImgCloseFun() {
    this.setData({
      ad: []
    })
  },

  openImgFun() {
    wx.navigateTo({
      url: this.data.ad[0].link,
    })
    // this.setData({
    //   'openData.openImgShow': false
    // })
  }
})