var util = require('../../../utils/util.js');
var api = require('../../../config/api.js');
var app = getApp();

Page({
  data: {
    hasLogin: true,
    userInfo: {
      nickName: '',
      avatarUrl: 'http://yanxuan.nosdn.127.net/8945ae63d940cc42406c3f67019c5cb6.png'
    },
    setUserInfo: {
      name: '',
      tel: '',
      avatar: ''
    },
    shadeMessage: ['拍照', '从手机相册选择', '取消'],
    shadeShow: false, // 遮罩显示隐藏
  },
  onLoad: function(options) {
    // 页面初始化 options为页面跳转所带来的参数
  },
  onReady: function() {

  },
  onShow: function() {
    if (app.globalData.hasLogin) {
      let userInfo = wx.getStorageSync('userInfo');
      this.setData({
        userInfo: userInfo
      })
    }
    this.getSetUp();
  },
  getSetUp() {
    let that = this;
    util.request(api.UserGetSetUp, {}, "POST").then(function (res) {
      if (res.errno === 0) {
        that.setData({
          setUserInfo: res.data
        })
      }
    });
  },
  bindPhoneNumber: function (e) {
    let that = this;
    if (e.detail.errMsg !== "getPhoneNumber:ok") {
      // 拒绝授权
      return;
    }

    if (!this.data.hasLogin) {
      wx.showToast({
        title: '绑定失败：请先登录',
        icon: 'none',
        duration: 2000
      });
      return;
    }

    util.request(api.AuthBindPhone, {
      iv: e.detail.iv,
      encryptedData: e.detail.encryptedData
    }, 'POST').then(function (res) {
      if (res.errno === 0) {
        wx.showToast({
          title: '绑定手机号码成功',
          icon: 'success',
          duration: 2000
        });
        that.getSetUp();
      }
    });
  },
  onHide: function() {
    // 页面隐藏

  },
  onUnload: function() {
    // 页面关闭
  },
  exitLogin: function () {
    wx.showModal({
      title: '',
      confirmColor: '#ED0E1B',
      content: '退出登录？',
      success: function (res) {
        if (!res.confirm) {
          return;
        }

        util.request(api.AuthLogout, {}, 'POST');
        app.globalData.hasLogin = false;
        wx.removeStorageSync('token');
        wx.removeStorageSync('userInfo');
        wx.reLaunch({
          url: '/pages/index2/index2'
        });
      }
    })
  },
  stopPageScroll() {
    return
  },
  /**
   * 选择图片方式 0拍照 1选文件 2取消
   */
  chooseType(e) {
    let index = e.currentTarget.dataset.index;
    if (index === 0) {
      this.cropImage('camera');
    } else if (index === 1) {
      this.cropImage('album');
    } else {
      this.setData({
        shadeShow: false
      })
    }
  },
  /**
   * 裁切图片
   * @param {Object} 事件
   */
  cropImage(type) {
    let that = this;
    wx.chooseImage({
      count: 1,
      sizeType: ['original', 'compressed'],
      sourceType: [type], // album 从相册选图，camera 使用相机，默认二者都有
      success: function (res) {
        console.log("从相册选图", res)
        wx.getImageInfo({
          src: res.tempFilePaths[0],
          success(res) {
            that.setData({
              shadeShow: false
            })
            wx.navigateTo({
              url: '../avatarCropper/avatarCropper?data=' + JSON.stringify(res)
            })
          }
        })
      }
    });
  },
  /**
   * 遮罩显示与隐藏
   */
  shadeFun() {
    this.setData({
      shadeShow: !this.data.shadeShow
    })
  },
  /**
   * 设置名字
   */
  setName() {
    let _nickName = this.data.setUserInfo.name  || this.data.userInfo.nickName;
    wx.navigateTo({
      url: "/pages/ucenter/nickName/nickName?nickName=" + _nickName
    });
  }
})